import { CollectionApiResponse, CollectionData, CollectionRequest } from '../interfaces/collection.interface';
import { Observable } from 'rxjs';
import { CollectionProvider } from './collection.provider';
import { HttpClient } from '@angular/common/http';
export declare class ApiCollectionProvider<T> extends CollectionProvider<T> {
    private readonly _endpoint;
    private readonly _httpClient;
    protected extraParams: {
        [name: string]: Observable<string | number | boolean | ReadonlyArray<string | number | boolean>>;
    };
    constructor(_endpoint: string | Observable<string>, _httpClient: HttpClient);
    append(name: string, value: string | number | boolean | ReadonlyArray<string | number | boolean> | Observable<string | number | boolean | ReadonlyArray<string | number | boolean>>): this;
    transform(request: CollectionRequest): Observable<CollectionData<T>>;
    protected getExtraParams(params: {
        [name: string]: Observable<string | number | boolean | ReadonlyArray<string | number | boolean>>;
    }): Observable<{}>;
    protected formatToCollectionData(response: CollectionApiResponse<T> | T[]): CollectionData<T>;
    protected getBackendFormat(request: CollectionRequest): {};
}
